diff --git a/src/main/java/net/minecraft/client/render/customatlas/Atlas.java b/src/main/java/net/minecraft/client/render/customatlas/Atlas.java
new file mode 100644
index 000000000..3334d6485
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/customatlas/Atlas.java
@@ -0,0 +1,117 @@
+package net.minecraft.client.render.customatlas;
+
+import java.io.BufferedReader;
+import java.io.InputStream;
+import java.io.InputStreamReader;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+public class Atlas {
+	
+	public final List<AtlasTile> tileList = new ArrayList<>();
+	
+	public int width;
+	public int height;
+	
+	public Atlas() {
+		
+	}
+	
+	public int size() {
+		return tileList.size();
+	}
+	
+	public void setSizeAuto() {
+		width = 1;
+		height = 1;
+		
+		for(int i=0; i < tileList.size(); i++) {
+			AtlasTile tile = tileList.get(i);
+			
+			width = Math.max(width, tile.x + 1);
+			height = Math.max(height, tile.y + 1);
+		}
+	}
+	
+	@Override
+	public String toString() {
+		return "Atlas[" + tileList.size() + " tiles, " + width + "x" + height + "]";
+	}
+	
+	public static Atlas read(InputStream in) {
+		Atlas atlas = new Atlas();
+		
+		Map<Integer, AtlasTile> map = new HashMap<>();
+		
+		BufferedReader br = null;
+		try {
+			br = new BufferedReader(new InputStreamReader(in));
+			
+			while(true) {
+				String line = br.readLine();
+				if(line == null) {
+					break;
+				}
+				
+				line = line.trim();
+				if(line.length() == 0 || line.startsWith("#")) {
+					continue;
+				}
+				
+				try {
+					int seperatorIndex = line.indexOf('=');
+					if(seperatorIndex < 0) {
+						throw new RuntimeException("No separator! Expected '='!");
+					}
+					
+					String key = line.substring(0, seperatorIndex);
+					String value = line.substring(seperatorIndex + 1);
+					
+					if(key.equals("size")) {
+						String[] size = value.split("x");
+						if(size.length != 2) {
+							throw new RuntimeException("Invalid size '" + size + "'! Expected <width>x<height>!");
+						}
+						
+						atlas.width = Integer.parseInt(size[0]);
+						atlas.height = Integer.parseInt(size[1]);
+					}else {
+						String[] pos = line.substring(0, seperatorIndex).split(",");
+						if(pos.length != 2) {
+							throw new RuntimeException("Invalid position '" + key + "'! Expected <x>,<y>!");
+						}
+						
+						int x = Integer.parseInt(pos[0]);
+						int y = Integer.parseInt(pos[1]);
+						
+						map.put(AtlasTile.getIndex(x, y), new AtlasTile(value, x, y));
+					}
+				}catch (Exception e) {
+					throw new RuntimeException("Reading line '" + line + "'", e);
+				}
+			}
+		}catch (Exception e) {
+			throw new RuntimeException("Loading atlas tiles", e);
+		}finally {
+			try {
+				br.close();
+			}catch (Exception e) {}
+			try {
+				in.close();
+			}catch (Exception e) {}
+		}
+		
+		atlas.tileList.addAll(map.values());
+		atlas.tileList.sort(AtlasTile.sorter);
+		
+		if(atlas.width <= 0 || atlas.height <= 0) {
+			atlas.setSizeAuto();
+		}
+		
+		
+		return atlas;
+	}
+
+}
diff --git a/src/main/java/net/minecraft/client/render/customatlas/AtlasTile.java b/src/main/java/net/minecraft/client/render/customatlas/AtlasTile.java
new file mode 100644
index 000000000..a4d76908f
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/customatlas/AtlasTile.java
@@ -0,0 +1,30 @@
+package net.minecraft.client.render.customatlas;
+
+import java.util.Comparator;
+
+public class AtlasTile {
+	
+	public static final Comparator<AtlasTile> sorter = (o1, o2) -> o1.x == o2.x ? o1.y - o2.y : o1.x - o2.x;
+	
+	public final String name;
+	public final int x;
+	public final int y;
+	
+	public AtlasTile(String name, int x, int y) {
+		if(x < 0 || x > 0xFFFF) {
+			throw new RuntimeException("x out of bounds: " + x);
+		}
+		if(y < 0 || y > 0xFFFF) {
+			throw new RuntimeException("y out of bounds: " + y);
+		}
+		
+		this.name = name;
+		this.x = x;
+		this.y = y;
+	}
+	
+	public static int getIndex(int x, int y) {
+		return (x & 0xFFFF) << 16 | (y & 0xFFFF);
+	}
+	
+}
diff --git a/src/main/java/net/minecraft/client/render/customatlas/CustomAtlasHandler.java b/src/main/java/net/minecraft/client/render/customatlas/CustomAtlasHandler.java
new file mode 100644
index 000000000..b1f3c7740
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/customatlas/CustomAtlasHandler.java
@@ -0,0 +1,216 @@
+package net.minecraft.client.render.customatlas;
+
+import java.awt.image.BufferedImage;
+import java.io.File;
+import java.util.ArrayList;
+import java.util.Enumeration;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+import java.util.zip.ZipEntry;
+import java.util.zip.ZipFile;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.texturepack.TexturePack;
+import net.minecraft.client.render.texturepack.TexturePackCustom;
+import net.minecraft.client.render.texturepack.TexturePackList;
+import net.minecraft.client.util.helper.Textures;
+
+public class CustomAtlasHandler {
+
+	private static Atlas legacyTerrainAtlas = null;
+	private static Atlas legacyItemsAtlas = null;
+	
+	public static Minecraft mc = Minecraft.getMinecraft(Minecraft.class);
+	
+	private static Map<String, BufferedImage> textureOverrides = new HashMap<>();
+	
+	private static void loadLegacyTiles() {
+		if(legacyTerrainAtlas != null && legacyItemsAtlas != null) {
+			return;
+		}
+		
+		log("Loading legacy tiles");
+
+		legacyTerrainAtlas = Atlas.read(CustomAtlasHandler.class.getResourceAsStream("/terrain.tiles"));
+		legacyItemsAtlas = Atlas.read(CustomAtlasHandler.class.getResourceAsStream("/items.tiles"));
+		
+		log(legacyTerrainAtlas.size() + " terrain tiles, " + legacyItemsAtlas.size() + " item tiles");
+	}
+	
+	public static void beforeRefreshTextures() {
+		textureOverrides.clear();
+		
+		List<TexturePack> texturePacks = mc.texturePackList.selectedPacks;
+		List<String> overrides = new ArrayList<>();
+		
+		log("Active Texture Packs: ");
+		for(int texturePackIndex=0; texturePackIndex < texturePacks.size(); texturePackIndex++) {
+			TexturePack texturePack = texturePacks.get(texturePackIndex);
+			log("  " + texturePack.manifest.getName());
+
+			if(texturePack.hasFile("/terrain.png")) {
+				log("    has terrain.png");
+				loadLegacyTiles();
+				loadAtlas(texturePack, legacyTerrainAtlas, "/terrain.png", "/assets/minecraft/textures/block/");
+			}
+			
+			if(texturePack.hasFile("/gui/items.png")) {
+				log("    has items.png");
+				loadLegacyTiles();
+				loadAtlas(texturePack, legacyItemsAtlas, "/gui/items.png", "/assets/minecraft/textures/item/");
+			}
+			
+			List<String> namespaces = findEntries(texturePack, "/assets/", (s) -> s.endsWith("/"));
+			if(namespaces != null) {
+				for(int namespaceIndex=0; namespaceIndex < namespaces.size(); namespaceIndex++) {
+					String namespace = namespaces.get(namespaceIndex);
+					
+					log("    namespace: " + namespace);
+					
+					List<String> customBlockAtlases = findEntries(texturePack, namespace + "textures/block/", (s) -> s.endsWith(".tiles"));
+					if(customBlockAtlases != null) {
+						for(int i=0; i < customBlockAtlases.size(); i++) {
+							String customAtlasPath = customBlockAtlases.get(i);
+							log("      found custom atlas: " + customAtlasPath);
+							loadAtlas(texturePack, Atlas.read(texturePack.getResourceAsStream(customAtlasPath)), customAtlasPath.replace(".tiles", ".png"), namespace + "textures/block/");
+						}
+					}
+					
+					List<String> customItemAtlases = findEntries(texturePack, namespace + "textures/item/", (s) -> s.endsWith(".tiles"));
+					if(customItemAtlases != null) {
+						for(int i=0; i < customItemAtlases.size(); i++) {
+							String customAtlasPath = customItemAtlases.get(i);
+							log("      found custom atlas: " + customAtlasPath);
+							loadAtlas(texturePack, Atlas.read(texturePack.getResourceAsStream(customAtlasPath)), customAtlasPath.replace(".tiles", ".png"), namespace + "textures/item/");
+						}
+					}
+
+				}
+			}
+			
+			overrides.clear();
+			overrides.addAll(textureOverrides.keySet());
+			for(int i=0; i < overrides.size(); i++) {
+				String override = overrides.get(i);
+				if(texturePack.hasFile(override)) {
+					textureOverrides.remove(override);
+				}
+			}
+		}
+	}
+	
+	public static void loadAtlas(TexturePack texturePack, Atlas atlas, String atlasTexturePath, String pathPrefix) {
+		if(atlas.width <= 0 || atlas.height <= 0) {
+			throw new IllegalArgumentException("Invalid atlas size: " + atlas.width + "x" + atlas.height);
+		}
+		
+		BufferedImage image = Textures.readImage(texturePack.getResourceAsStream(atlasTexturePath));
+		if(image == null) {
+			throw new RuntimeException("Atlas image does not exist: " + atlasTexturePath);
+		}
+		
+		int tileWidth = image.getWidth() / atlas.width;
+		int tileHeight = image.getHeight() / atlas.height;
+		
+		List<AtlasTile> atlasTiles = atlas.tileList;
+		for(int tileIndex = 0; tileIndex < atlasTiles.size(); tileIndex++) {
+			AtlasTile atlasTile = atlasTiles.get(tileIndex);
+			
+			BufferedImage tileImage = image.getSubimage(tileWidth * atlasTile.x, tileHeight * atlasTile.y, tileWidth, tileHeight);
+			
+			String path = pathPrefix + atlasTile.name + ".png";
+			textureOverrides.put(path, tileImage);
+		}
+	}
+	
+	public static List<String> findEntries(TexturePack texturePack, String path, Filter filter) {
+		if(!path.startsWith("/")) {
+			throw new IllegalArgumentException(path);
+		}
+		
+		if(texturePack instanceof TexturePackCustom) {
+			TexturePackCustom texturePackCustom = (TexturePackCustom) texturePack;
+			
+			if(texturePackCustom.file.isDirectory()) {
+				List<String> result = new ArrayList<>();
+				
+				File searchDirectory = new File(texturePackCustom.file, path.substring(1));
+				File[] files = searchDirectory.listFiles();
+				if(files == null) {
+					return null;
+				}
+				
+				for(int i=0; i < files.length; i++) {
+					File file = files[i];
+					String relativePath = files[i].getAbsolutePath().substring(texturePackCustom.file.getAbsolutePath().length());
+					relativePath = relativePath.replace('\\', '/');
+					if(file.isDirectory()) {
+						relativePath = relativePath + "/";
+					}
+					if(filter == null || filter.accept(relativePath)) {
+						result.add(relativePath);
+					}
+				}
+				return result;
+			}
+			if(texturePackCustom.file.isFile()) {
+				path = path.substring(1);
+				
+				List<String> result = new ArrayList<>();
+				
+				ZipFile zipFile = null;
+				try {
+					zipFile = new ZipFile(texturePackCustom.file);
+					
+					Enumeration<? extends ZipEntry> entries = zipFile.entries();
+					while(entries.hasMoreElements()) {
+						String entry = entries.nextElement().toString();
+						if(!entry.startsWith(path)) {
+							continue;
+						}
+						
+						entry = entry.substring(path.length());
+						if(entry.length() == 0) {
+							continue;
+						}
+						
+						// Only find entries in the given directory, no subdirectories
+						if(entry.indexOf('/') != entry.lastIndexOf('/')) {
+							continue;
+						}
+						
+						entry = "/" + path + entry;
+						if(filter == null || filter.accept(entry)) {
+							result.add(entry);
+						}
+					}
+				}catch (Exception e) {
+					throw new RuntimeException(e);
+				}finally {
+					try {
+						zipFile.close();
+					}catch (Exception e) {}
+				}
+				return result;
+			}
+		}
+		
+		return null;
+	}
+	
+	public static BufferedImage getTextureOverride(TexturePackList texturePackList, String path) {
+		return textureOverrides.get(path);
+	}
+	
+	public static void log(String str) {
+		System.out.println(str);
+	}
+	
+	static interface Filter {
+		
+		public boolean accept(String string);
+		
+	}
+	
+}
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexture.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexture.java
index ed38f663a..05e8758cf 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexture.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexture.java
@@ -1,25 +1,30 @@
 package net.minecraft.client.render.dynamictexture;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import org.jetbrains.annotations.NotNull;
 
 public abstract class DynamicTexture {
 
 	public Minecraft mc = Minecraft.getMinecraft(this);
-	public IconCoordinate texture;
+	@NotNull
+	public final IconCoordinate targetTexture;
 	public byte[] imageData;
-	
+
+	public DynamicTexture(@NotNull IconCoordinate targetTexture) {
+		this.targetTexture = targetTexture;
+	}
+
 	public abstract void postInit();
 	
 	public abstract void update();
 
-	public boolean runUpdates() {
-		return mc.gameSettings.animations.value != 0;
+	public boolean runUpdates(boolean isPaused) {
+		return mc.gameSettings.animations.value != 0 && !isPaused;
 	}
 	
-	public void setTexture(IconCoordinate texture) {
-		this.texture = texture;
-		this.imageData = new byte[texture.width * texture.height * 4];
+	public void initTexture() {
+		this.imageData = new byte[targetTexture.width * targetTexture.height * 4];
 	}
 	
 	public static int pmod(int a, int b) {
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureAbstractClock.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureAbstractClock.java
index c9f4618d1..77be01d24 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureAbstractClock.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureAbstractClock.java
@@ -3,8 +3,7 @@ package net.minecraft.client.render.dynamictexture;
 import java.awt.image.BufferedImage;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.stitcher.AtlasStitcher;
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.util.helper.Textures;
 
 public abstract class DynamicTextureAbstractClock extends DynamicTextureRotating{
@@ -28,7 +27,7 @@ public abstract class DynamicTextureAbstractClock extends DynamicTextureRotating
 			}
 		}
 	}
-	public boolean runUpdates() {
-		return true;
+	public boolean runUpdates(boolean isPaused) {
+		return !isPaused;
 	}
 }
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCalendar.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCalendar.java
index f31003ef1..415522e9a 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCalendar.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCalendar.java
@@ -1,15 +1,13 @@
 package net.minecraft.client.render.dynamictexture;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.stitcher.TextureRegistry;
-import net.minecraft.core.item.Item;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.world.season.SeasonManagerCycle;
 
 public class DynamicTextureCalendar extends DynamicTextureAbstractClock {
 
 	public DynamicTextureCalendar(Minecraft minecraft) {
-		super(minecraft, "/misc/dialseason.png", TextureRegistry.getTexture("minecraft:item/tool_calendar"));
+		super(minecraft, "/assets/minecraft/textures/misc/dialseason.png", TextureRegistry.getTexture("minecraft:item/tool_calendar"));
 	}
 
 	@Override
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureClock.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureClock.java
index dd23db0e3..657670f90 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureClock.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureClock.java
@@ -1,15 +1,13 @@
 package net.minecraft.client.render.dynamictexture;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.world.Dimension;
-import net.minecraft.core.item.Item;
 
 public class DynamicTextureClock extends DynamicTextureAbstractClock{
 
 	public DynamicTextureClock(Minecraft minecraft) {
-		super(minecraft, "/misc/dial.png", TextureRegistry.getTexture("minecraft:item/tool_clock"));
+		super(minecraft, "/assets/minecraft/textures/misc/dial.png", TextureRegistry.getTexture("minecraft:item/tool_clock"));
 	}
 
 	@Override
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java
index 9603c1257..48c85a82f 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java
@@ -5,7 +5,7 @@ import static java.lang.Math.*;
 import java.awt.image.BufferedImage;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.Dimension;
 
@@ -20,36 +20,37 @@ public class DynamicTextureCompass extends DynamicTexture {
 	
 	private double scaleFactor;
 	
-	public DynamicTextureCompass(Minecraft minecraft) {
+	public DynamicTextureCompass(Minecraft minecraft, IconCoordinate iconCoordinate) {
+		super(iconCoordinate);
 		this.mc = minecraft;
 	}
 
 	@Override
 	public void postInit() {
-		setTexture(TextureRegistry.getTexture("minecraft:item/tool_compass"));
+		initTexture();
 		
-		BufferedImage atlas = texture.parentAtlas.atlas;
-		compassImageData = new byte[texture.getArea() * 4];
+		BufferedImage atlas = targetTexture.parentAtlas.atlas;
+		compassImageData = new byte[targetTexture.getArea() * 4];
 
-		for(int x = 0; x < texture.width; x++) {
-			for(int y = 0; y < texture.height; y++) {
-				putPixel(compassImageData, y * texture.width + x, atlas.getRGB(texture.iconX + x, texture.iconY + y));
+		for(int x = 0; x < targetTexture.width; x++) {
+			for(int y = 0; y < targetTexture.height; y++) {
+				putPixel(compassImageData, y * targetTexture.width + x, atlas.getRGB(targetTexture.iconX + x, targetTexture.iconY + y));
 			}
 		}
 		
-		scaleFactor = texture.width / 16.0;
+		scaleFactor = targetTexture.width / 16.0;
 	}
 	@Override
-	public boolean runUpdates() {
-		return true;
+	public boolean runUpdates(boolean isPaused) {
+		return !isPaused;
 	}
 
 	@Override
 	public void update() {
 
-		for (int _x = 0; _x < texture.width; _x++) {
-			for(int _y = 0; _y < texture.height; _y++) {
-				int i = _y * texture.width + _x;
+		for (int _x = 0; _x < targetTexture.width; _x++) {
+			for(int _y = 0; _y < targetTexture.height; _y++) {
+				int i = _y * targetTexture.width + _x;
 
 				int a = this.compassImageData[i * 4 + 3] & 0xFF;
 				int r = this.compassImageData[i * 4 + 0] & 0xFF;
@@ -107,13 +108,13 @@ public class DynamicTextureCompass extends DynamicTexture {
 		int b;
 		int a;
 
-        double xs = (texture.width / 2.0) + 0.5;
-		double ys = (texture.height / 2.0) - 0.5;
+        double xs = (targetTexture.width / 2.0) + 0.5;
+		double ys = (targetTexture.height / 2.0) - 0.5;
 		
 		for(int i = (int)(-4 * scaleFactor); i <= (int)(4 * scaleFactor); ++i) {
 			x2 = (int)(xs + y * (double)i * 0.3D);
 			y2 = (int)(ys - x * (double)i * 0.3D * 0.5D);
-			j = y2 * texture.width + x2;
+			j = y2 * targetTexture.width + x2;
 			r = 100;
 			g = 100;
 			b = 100;
@@ -128,7 +129,7 @@ public class DynamicTextureCompass extends DynamicTexture {
 		for(int i = (int)(-8 * scaleFactor); i <= (int)(16 * scaleFactor); ++i) {
 			x2 = (int)(xs + x * (double)i * 0.3D);
 			y2 = (int)(ys + y * (double)i * 0.3D * 0.5D);
-			j = y2 * texture.width + x2;
+			j = y2 * targetTexture.width + x2;
 			r = i >= 0 ? 255 : 100;
 			g = i >= 0 ? 20 : 100;
 			b = i >= 0 ? 20 : 100;
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java
index 4c9c09f0e..f473eab84 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java
@@ -3,37 +3,35 @@ package net.minecraft.client.render.dynamictexture;
 import java.awt.image.BufferedImage;
 import java.util.Random;
 
-import com.b100.json.element.JsonObject;
-
-import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
-import net.minecraft.client.render.texturepack.TexturePack;
+import net.minecraft.client.render.texture.meta.AnimationProperties;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texturepack.TexturePackException;
-import net.minecraft.client.util.helper.TexturePackJsonHelper;
-import net.minecraft.client.util.helper.Textures;
 
 public class DynamicTextureCustom extends DynamicTexture {
 	
-	private static Random rand = new Random();
-	
-	private int frameCount;
-	private byte[] frameData;
-	
-	private int[] frames;
-	private int frametime = 1;
-	private boolean random = false;
-	private boolean interpolate = false;
-	private boolean tile2x2 = false;
+	private static final Random rand = new Random();
 	
+	private final int frameCount;
+	private final byte[] frameData;
+
+	private final AnimationProperties properties;
+
+	private int currentIndex = 0;
+	private final int indices;
+
 	private int currentFrame = -1;
 	private int previousFrame = -1;
-	private int nextFrameDelay = 0;
+	private int delayUntilNextFrame = 0;
+	private int frameLength = 0;
+
+	private boolean tickWhenPaused = false;
 	
-	public DynamicTextureCustom(Minecraft mc, TexturePack texturePack, String animationSource, String texturePath, boolean shouldBeTiled) {
-		IconCoordinate texture = TextureRegistry.getTexture(texturePath);
-		
-		BufferedImage image = Textures.readImage(texturePack.getResourceAsStream(animationSource));
+	public DynamicTextureCustom(IconCoordinate texture, AnimationProperties animationProperties) {
+		super(texture);
+
+		this.properties = animationProperties;
+
+		BufferedImage image = texture.getImageStorage();
 		try {
 			if(image == null) {
 				throw new TexturePackException("Could not load image!");
@@ -42,91 +40,62 @@ public class DynamicTextureCustom extends DynamicTexture {
 				throw new TexturePackException("Height is smaller than width!");
 			}
 		}catch (TexturePackException e) {
-			throw new TexturePackException("Error in animation " + animationSource, e);
+			throw new TexturePackException("Error in animation " + texture.namespaceId, e);
 		}
 
-		frameCount = image.getHeight() / image.getWidth();
-		
-		String jsonFilePath = animationSource.replace(".png", ".json");
-		if(texturePack.hasFile(jsonFilePath)) {
-			try {
-				JsonObject rootObject = TexturePackJsonHelper.readJsonObject(texturePack, jsonFilePath);
-				
-				if(rootObject.has("frametime")) {
-					this.frametime = TexturePackJsonHelper.getInteger(rootObject, "frametime");
-				}
-				if(rootObject.has("random")) {
-					this.random = TexturePackJsonHelper.getBoolean(rootObject, "random");
-				}
-				if(rootObject.has("interpolate")) {
-					this.interpolate = TexturePackJsonHelper.getBoolean(rootObject, "interpolate");
-				}
-				if(rootObject.has("frames")) {
-					this.frames = TexturePackJsonHelper.getIntArray(rootObject, "frames");
-
-					for(int i=0; i < frames.length; i++) {
-						if(frames[i] >= frameCount) {
-							throw new TexturePackException("Invalid frame number: " + frames[i]);
-						}
-					}
-				}
-				if(rootObject.has("tile2x2")) {
-					this.tile2x2 = TexturePackJsonHelper.getBoolean(rootObject, "tile2x2");
+		int width = image.getWidth();
+		int height = image.getHeight();
+
+		int tileWidth = width;
+		int tileHeight = (animationProperties.height * width) / animationProperties.width ;
+
+		texture.setDimension(tileWidth, tileHeight);
+
+		this.frameCount = height / tileHeight;
+
+		if (animationProperties.frames != null) {
+			indices = animationProperties.frames.size();
+			for (AnimationProperties.Frame f : animationProperties.frames) {
+				if (f.index >= frameCount) {
+					throw new TexturePackException("Animation in '" + texture.namespaceId + "' illegally attempts to reference index '" + f.index + "' when theres only '" + frameCount + "' possible frames!");
 				}
-			}catch (Exception e) {
-				throw new TexturePackException("Error in " + jsonFilePath, e);
 			}
+		} else {
+			indices = frameCount;
 		}
-		
-		int tileCount = 1;
-		if(tile2x2) {
-			tileCount = 2;
-		}
-		
-		int res = image.getWidth();
-		int tiledRes = res * tileCount;
-		
-		texture.setDimension(tiledRes, tiledRes);
-		texture.parentAtlas.dontSetSize.add(texture);
-		setTexture(texture);
-		
-		frameData = new byte[tiledRes * tiledRes * 4 * frameCount];
+
+
+		frameData = new byte[tileWidth * tileHeight * 4 * frameCount];
 		for(int frame=0; frame < frameCount; frame++) {
-			for(int x=0; x < res; x++) {
-				for(int y=0; y < res; y++) {
-					int c = image.getRGB(x, frame * res + y);
-					for(int tileX = 0; tileX < tileCount; tileX++) {
-						for(int tileY = 0; tileY < tileCount; tileY++) {
-							int x1 = tileX * res + x;
-							int y1 = tileY * res + y;
-							int i = frame * tiledRes * tiledRes + y1 * tiledRes + x1;
-							putPixel(frameData, i, c);
-						}
-					}
+			for(int x=0; x < tileWidth; x++) {
+				for(int y=0; y < tileHeight; y++) {
+					int c = image.getRGB(x, frame * tileHeight + y);
+					int i = frame * tileWidth * tileHeight + y * tileWidth + x;
+					putPixel(frameData, i, c);
 				}
 			}
 		}
+
+		tickWhenPaused = texture.parentAtlas.tickWhenPaused();
 	}
 
 	@Override
 	public void postInit() {
-		
+		initTexture();
 	}
 	
 	@Override
 	public void update() {
-		if(interpolate) {
-			if(nextFrameDelay > 0) {
-				nextFrameDelay--;
+		if(properties.interpolate) {
+			if(delayUntilNextFrame > 0) {
+				delayUntilNextFrame--;
 			}
 			
-			if(nextFrameDelay <= 0) {
-				nextFrameDelay = frametime;
-				previousFrame = currentFrame;
-				currentFrame = getNextFrame();
+			if(delayUntilNextFrame <= 0) {
+				progressFrame();
 			}
 
-			float blendFactor = 1.0f - nextFrameDelay / (float) frametime;
+			float blendFactor = 1.0f - delayUntilNextFrame / (float) frameLength;
 			
 			if(previousFrame == -1) {
 				transferFrame(currentFrame);
@@ -137,51 +106,54 @@ public class DynamicTextureCustom extends DynamicTexture {
 			return;
 		}
 		
-		if(nextFrameDelay > 0) {
-			nextFrameDelay--;
-			if(nextFrameDelay > 0) {
+		if(delayUntilNextFrame > 0) {
+			delayUntilNextFrame--;
+			if(delayUntilNextFrame > 0) {
 				return;
 			}
 		}
 		
-		nextFrameDelay = frametime;
-		previousFrame = currentFrame;
-		currentFrame = getNextFrame();
-		
+		progressFrame();
+
 		if(currentFrame != previousFrame) {
 			transferFrame(currentFrame);
 		}
 	}
+	private void progressFrame() {
+		frameLength = delayUntilNextFrame = getNextFrameDelay();
+		if (properties.random) {
+			currentIndex = rand.nextInt(indices);
+		} else {
+			currentIndex = (currentIndex + 1) % indices;
+		}
+		previousFrame = currentFrame;
+		currentFrame = getNextFrame();
+	}
 	
 	private int getNextFrame() {
-		int max = frameCount;
-		
-		if(frames != null) {
-			max = frames.length;
-		}
-		
-		if(random) {
-			return rand.nextInt(max);
-		}else {
-			return (currentFrame + 1) % max;
-		}
+		return properties.frames == null ? currentIndex : properties.frames.get(currentIndex).index;
+	}
+
+	private int getNextFrameDelay() {
+		if (properties.frames == null) return properties.frametime;
+		return properties.frames.get(currentIndex).time;
 	}
 	
 	private void transferFrame(int frame) {
-		if(frames != null) {
-			frame = frames[frame];
-		}
-		
-		for(int x0 = 0; x0 < texture.width; x0++) {
-			for(int y0 = 0; y0 < texture.height; y0++) {
-				int i = (frame * texture.getArea() + y0 * texture.width + x0) << 2;
-				int j = (y0 * texture.height + x0) << 2;
-				
-				imageData[j + 0] = frameData[i + 0];
-				imageData[j + 1] = frameData[i + 1];
-				imageData[j + 2] = frameData[i + 2];
-				imageData[j + 3] = frameData[i + 3];
+		try {
+			for(int x0 = 0; x0 < targetTexture.width; x0++) {
+				for(int y0 = 0; y0 < targetTexture.height; y0++) {
+					int i = (frame * targetTexture.getArea() + y0 * targetTexture.width + x0) << 2;
+					int j = (y0 * targetTexture.width + x0) << 2;
+
+					imageData[j + 0] = frameData[i + 0];
+					imageData[j + 1] = frameData[i + 1];
+					imageData[j + 2] = frameData[i + 2];
+					imageData[j + 3] = frameData[i + 3];
+				}
 			}
+		} catch (Exception e) {
+			e.printStackTrace();
 		}
 	}
 	
@@ -191,16 +163,11 @@ public class DynamicTextureCustom extends DynamicTexture {
 		}else if(blendFactor >= 1.0f) {
 			transferFrame(frame2);
 		}else {
-			if(frames != null) {
-				frame1 = frames[frame1];
-				frame2 = frames[frame2];
-			}
-			
-			for(int x0 = 0; x0 < texture.width; x0++) {
-				for(int y0 = 0; y0 < texture.height; y0++) {
-					int i = (frame1 * texture.getArea() + y0 * texture.width + x0) << 2;
-					int j = (frame2 * texture.getArea() + y0 * texture.width + x0) << 2;
-					int k = (y0 * texture.width + x0) << 2;
+			for(int x0 = 0; x0 < targetTexture.width; x0++) {
+				for(int y0 = 0; y0 < targetTexture.height; y0++) {
+					int i = (frame1 * targetTexture.getArea() + y0 * targetTexture.width + x0) << 2;
+					int j = (frame2 * targetTexture.getArea() + y0 * targetTexture.width + x0) << 2;
+					int k = (y0 * targetTexture.width + x0) << 2;
 
 					imageData[k + 0] = blend(frameData[i + 0], frameData[j + 0], blendFactor);
 					imageData[k + 1] = blend(frameData[i + 1], frameData[j + 1], blendFactor);
@@ -215,4 +182,8 @@ public class DynamicTextureCustom extends DynamicTexture {
 		int c = (int) ((a & 0xFF) * (1.0f - factor) + (b & 0xFF) * factor);
 		return (byte) c;
 	}
+	@Override
+	public boolean runUpdates(boolean isPaused) {
+		return (!isPaused || tickWhenPaused);
+	}
 }
